// NxtActor.java

import ch.aplu.jgamegrid.*;

class NxtActor extends Actor
{
  private enum State {STOP, FORWARD, BACKWARD, LEFT, RIGHT};
  private final double linearSpeed = 1;
  private final double angularSpeed = 0.70;
  private State state = State.STOP;
  
  public NxtActor()
  {
    super(true, "sprites/roby.gif");
  }
  
  public void stop()
  {
    state = State.STOP;  
  }  

  public void forward()
  {
    state = State.FORWARD;  
  }  
  
  public void backward()
  {
    state = State.BACKWARD;  
  }  
  
  public void left()
  {
    state = State.LEFT;  
  }  
  
  public void right()
  {
    state = State.RIGHT;  
  }
  
 public void act()
 {
   switch (state)
   {
     case FORWARD:
       displace(linearSpeed);
       break;
     case BACKWARD:
       displace(-linearSpeed);
       break;
     case LEFT:
       setDirection(getDirection() - angularSpeed);
       break;
     case RIGHT:
       setDirection(getDirection() + angularSpeed);
       break;
   }  
 }  
 
 public Location getSensorLocation()
 {
   int d = 10;
   double xSendor = getX() + d * Math.cos(Math.toRadians(getDirection()));
   double ySendor = getY() + d * Math.sin(Math.toRadians(getDirection()));
   return new Location((int)xSendor, (int)ySendor);
 }
 
 public void init()
 {
   state = State.STOP;
   setLocation(getLocationStart());
   setDirection(getDirectionStart());
 }  
} 