// Slave.java

import ch.aplu.tcp.*;
import ch.aplu.util.*;
import javax.swing.JOptionPane;

public class Slave extends TcpNode
  implements TcpNodeListener
{
  private final String nickname = "NxtSlave";
  private static String sessionID;
  private SimRover rover = new SimRover();
  private Console c = Console.init();

  public Slave()
  {
    if (!rover.bluetoothConnect())
      return;
    addTcpNodeListener(this);
    connect(sessionID, nickname);
    while (true)
    {
      int value = rover.getIntensity();
      System.out.println("v = " + value);
      sendMessage("" + value);
      Console.delay(100);
    }
  }

  public void nodeStateChanged(TcpNodeState state)
  {
    if (state == TcpNodeState.CONNECTED)
      System.out.println("Waiting for NxtMaster...");
  }

  public void statusReceived(String text)
  {
    if (text.contains("NxtMaster") && !text.contains("Disconnected"))
      c.setTitle("NxtMaster connected");
    if (text.contains("Disconnected"))
      c.setTitle("NxtMaster disconnected");
  }

  public void messageReceived(String sender, String text)
  {
    switch (text.charAt(0))
    {
      case '0':
        rover.stop();
        break;
      case '1':
        rover.forward();
        break;
      case '2':
        rover.backward();
        break;
      case '3':
        rover.left();
        break;
      case '4':
        rover.right();
        break;
    }
  }

  public static void main(String[] args)
  {
    sessionID = JOptionPane.showInputDialog(null, "SessionID:", "");
    if (sessionID != null)
      new Slave();
  }
}
